;; CodePage specific utilityes for Mule.
;; Copyright (C) 1997 Free Software Foundation, Inc.
;; This file is part of Mule (MULtilingual Enhancement of GNU Emacs).
;; This file contains ISO8859-2 charcters.

;; Mule is free software distributed in the form of patches to GNU Emacs.
;; You can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.

;; Mule is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; 97.3.1  K.Fujii <JAE01012@niftyserve.or.jp>.
;;  Code Page utilities.

(require 'primary)

;; Code Page 437 (U.S.) staff

(define-ccl-program ccl-read-codepage-437
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,A'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,AG(B  ?,A|(B  ?,Ai(B  ?,Ab(B  ?,Ad(B  ?,A`(B  ?,Ae(B  ?,Ag(B  ?,Ak(B  ?,Aj(B  ?,Ah(B  ?,Ao(B  ?,An(B  ?,Al(B  ?,AD(B  ?,AE(B
	?,AI(B  ?,Af(B  ?,AF(B  ?,At(B  ?,Av(B  ?,Ar(B  ?,A{(B  ?,Ay(B  32  ?,AV(B  ?,A\(B  ?,A"(B  ?,A#(B  ?,A%(B  32  32
	?,Aa(B  ?,Am(B  ?,As(B  ?,Az(B  ?,Aq(B  ?,AQ(B  ?,A*(B  ?,A:(B  ?,A?(B  32  ?,A,(B  ?,A=(B  ?,A<(B  ?,A!(B  ?,A+(B  ?,A;(B
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	?,Fa(B  ?,A_(B  ?,FC(B  ?,FP(B  ?,FS(B  ?,Fs(B  ?,A5(B  ?,Fc(B  ?,Fv(B  ?,Fh(B  ?,FY(B  ?,Fd(B  32  ?,Ax(B  32  32
	32  ?,A1(B  32  32  32  32  ?,Aw(B  32  ?,A0(B  32  ?,A7(B  32  32  ?,A2(B  32  32]))))
  "CCL program to read Code Page 437.")

(define-ccl-program ccl-write-codepage-437
  '(1
    ((read r0)
     (loop
      (if (r0 != 129)			; lc-ltn1 == 129
	  (if (r0 != 134)		; lc-grk == 134
	      (write-read-repeat r0)
	    ((read r0)
	     (r0 -= 160)
	     (write-read-repeat
	      r0
	      [32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  226 32  32  32  32  233 32  32  32  32  32  32  32 
	       32  32  32  228 32  32  232 32  32  234 32  32  32  32  32  32 
	       32  224 32  231 235 32  32  32  32  32  32  32  230 32  32  32
	       32  32  32  229 32  32  32  32  32  32  32  32  32  32  32  32])))
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  173 155 156 32  158 124 37  32  32  166 174 170 32  32  32
	   248 241 253 32  32  230 36  249 32  32  167 175 172 171 32  168
	   32  32  32  32  142 143 146 128 32  144 32  32  32  32  32  32
	   32  165 32  32  32  32  153 32  32  32  32  32  154 32  32  32
	   133 160 131 32  132 134 145 135 138 130 136 137 141 161 140 139
	   32  164 149 162 147 32  148 246 32  151 163 150 129 32  32  152]))
	))))
  "CCL program to write Code Page 437.")

(make-coding-system
 '*cp-437* 4
 ?c "Coding-system used for Code Page 437"
 2
 (cons ccl-read-codepage-437 ccl-write-codepage-437))

(defun set-codepage-environment-437 ()
  "Make Code Page 437 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-437*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-437*)
  (set-file-coding-system '*cp-437*)
  (set-display-coding-system '*cp-437*)
  (setq-default quail-current-package (assoc "cp-437" quail-package-alist)))

(put 'cp-437 'primary-function 'set-codepage-environment-437)
(add-hook 'quail-package-alist '("cp-437" "quail/codepage"))

;; Code Page 850 staff.

(define-ccl-program ccl-read-codepage-850
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,A'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,AG(B  ?,A|(B  ?,Ai(B  ?,Ab(B  ?,Ad(B  ?,A`(B  ?,Ae(B  ?,Ag(B  ?,Aj(B  ?,Ak(B  ?,Ah(B  ?,Ao(B  ?,An(B  ?,Al(B  ?,AD(B  ?,AE(B
	?,AI(B  ?,Af(B  ?,AF(B  ?,At(B  ?,Av(B  ?,Ar(B  ?,A{(B  ?,Ay(B  32  ?,AV(B  ?,A\(B  ?,Ax(B  ?,A#(B  ?,AX(B  ?,AW(B  32
	?,Aa(B  ?,Am(B  ?,As(B  ?,Az(B  ?,Aq(B  ?,AQ(B  ?,A*(B  ?,A:(B  ?,A?(B  ?,A.(B  ?,A,(B  ?,A=(B  ?,A<(B  ?,A!(B  ?,A+(B  ?,A;(B
	32  32  32  32  32  ?,AA(B  ?,AB(B  ?,A@(B  ?,A)(B  32  32  32  32  ?,A"(B  ?,A%(B  32
	32  32  32  32  32  32  ?,Ac(B  ?,AC(B  32  32  32  32  32  32  32  ?,A$(B
	?,Ap(B  ?,AP(B  ?,AJ(B  ?,AK(B  ?,AH(B  32  ?,AM(B  ?,AN(B  ?,AO(B  32  32  32  32  ?,A&(B  ?,AL(B  32
	?,AS(B  ?,A_(B  ?,AT(B  ?,AR(B  ?,Au(B  ?,AU(B  32  ?,A^(B  ?,A~(B  ?,AZ(B  ?,A[(B  ?,AY(B  ?,A}(B  ?,A](B  ?,A/(B  ?,A4(B
	?,A-(B  ?,A1(B  32  ?,A>(B  ?,A6(B  ?,A'(B  ?,Aw(B  ?,A8(B  ?,A0(B  ?,A((B  ?,A7(B  ?,A9(B  ?,A3(B  ?,A2(B  32  32]))))
  "CCL program to read Code Page 850.")

(define-ccl-program ccl-write-codepage-850
  '(1
    ((read r0)
     (loop
      (if (r0 != 129)			; lc-ltn1 == 129
	  (write-read-repeat r0)
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  173 189 156 164 190 221 245 249 184 166 174 170 240 169 238
	   248 241 253 232 239 230 244 250 247 231 167 175 172 171 243 168
	   183 181 182 199 142 143 146 128 212 144 210 211 222 214 215 216
	   210 165 227 224 226 229 153 158 157 235 233 234 154 236 232 225
	   133 160 131 198 132 134 145 135 130 138 136 137 141 161 140 139
	   208 164 149 224 147 228 148 246 157 151 163 150 129 236 231 152])
	 )))))
  "CCL program to write Code Page 850.")

(make-coding-system
 '*cp-850* 4
 ?c "Coding-system used for Code Page 850"
 2
 (cons ccl-read-codepage-850 ccl-write-codepage-850))

(defun set-codepage-environment-850 ()
  "Make Code Page 850 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-850*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-850*)
  (set-file-coding-system '*cp-850*)
  (set-display-coding-system '*cp-850*)
  (setq-default quail-current-package (assoc "cp-850" quail-package-alist)))

(put 'cp-850 'primary-function 'set-codepage-environment-850)
(add-hook 'quail-package-alist '("cp-850" "quail/codepage"))

;; Code Page 852 staff

(define-ccl-program ccl-read-codepage-852
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,B'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,BG(B  ?,B|(B  ?,Bi(B  ?,Bb(B  ?,Bd(B  ?,By(B  ?,Bf(B  ?,Bg(B  ?,B3(B  ?,Bk(B  ?,BU(B  ?,Bu(B  ?,Bn(B  ?,B,(B  ?,BD(B  ?,BF(B
	?,BI(B  ?,BE(B  ?,Be(B  ?,Bt(B  ?,Bv(B  ?,B%(B  ?,B5(B  ?,B&(B  ?,B6(B  ?,BV(B  ?,B\(B  ?,B+(B  ?,B;(B  ?,B#(B  ?,BW(B  ?,Bh(B
	?,Ba(B  ?,Bm(B  ?,Bs(B  ?,Bz(B  ?,B!(B  ?,B1(B  ?,B.(B  ?,B>(B  ?,BJ(B  ?,Bj(B  32  ?,B<(B  ?,BH(B  ?,B:(B  ?,A+(B  ?,A;(B
	32  32  32  32  32  ?,BA(B  ?,BB(B  ?,BL(B  ?,B*(B  32  32  32  32  ?,B/(B  ?,B?(B  32
	32  32  32  32  32  32  ?,BC(B  ?,Bc(B  32  32  32  32  32  32  32  ?,B$(B
	?,Bp(B  ?,BP(B  ?,BO(B  ?,BK(B  ?,Bo(B  ?,BR(B  ?,BM(B  ?,BN(B  ?,Bl(B  32  32  32  32  ?,B^(B  ?,BY(B  32
	?,BS(B  ?,B_(B  ?,BT(B  ?,BQ(B  ?,Bq(B  ?,Br(B  ?,B)(B  ?,B9(B  ?,B@(B  ?,BZ(B  ?,B`(B  ?,B[(B  ?,B}(B  ?,B](B  ?,B~(B  ?,B4(B
	?,B-(B  ?,B=(B  ?,B2(B  ?,B7(B  ?,B"(B  ?,B'(B  ?,Bw(B  ?,B8(B  ?,B0(B  ?,B((B  ?,B(B  ?,B{(B  ?,BX(B  ?,Bx(B  32  32]))))
  "CCL program to read Code Page 852.")

(define-ccl-program ccl-write-codepage-852
  '(1
    ((read r0)
     (loop
      (if (r0 != 130)			; lc-ltn2 == 130
	  (if (r0 != 129)		; lc-ltn1 == 129
	      (write-read-repeat r0)
	    ((read r0)
	     (r0 -= 160)
	     (write-read-repeat
	      r0
	      [32  32  32  32  32  32  32  32  32  32  32  174 32  32  32  32
	       32  32  32  32  32  32  36  32  32  32  32  175 32  32  32  32
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32])))
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  164 244 157 207 149 151 245 249 230 184 155 141 240 166 189
	   248 165 242 136 239 150 152 243 247 231 185 173 171 241 167 190
	   232 181 182 198 142 145 143 128 172 144 169 211 183 214 215 210
	   209 228 213 224 226 138 153 158 252 222 233 235 154 237 221 225
	   234 160 131 199 132 146 134 135 159 130 169 137 216 161 140 212
	   208 228 229 162 147 139 148 246 253 133 163 251 129 236 238 250])
	 )))))
  "CCL program to write Code Page 852.")

(make-coding-system
 '*cp-852* 4
 ?c "Coding-system used for Code Page 852"
 2
 (cons ccl-read-codepage-852 ccl-write-codepage-852))

(defun set-codepage-environment-852 ()
  "Make Code Page 852 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-852*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-852*)
  (set-file-coding-system '*cp-852*)
  (set-display-coding-system '*cp-852*)
  (setq-default quail-current-package (assoc "cp-852" quail-package-alist)))

(put 'cp-852 'primary-function 'set-codepage-environment-852)
(add-hook 'quail-package-alist '("cp-852" "quail/codepage"))

;; Code Page 860 (Portuguese) staff

(define-ccl-program ccl-read-codepage-860
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,A'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,AG(B  ?,A|(B  ?,Ai(B  ?,Ab(B  ?,Ac(B  ?,A`(B  ?,AA(B  ?,Ag(B  ?,Aj(B  ?,AJ(B  ?,Ah(B  ?,AM(B  ?,AT(B  ?,Al(B  ?,AC(B  ?,AB(B
	?,AI(B  ?,A@(B  ?,AH(B  ?,At(B  ?,Au(B  ?,Ar(B  ?,AZ(B  ?,Ay(B  ?,AL(B  ?,AU(B  ?,A\(B  ?,A"(B  ?,A#(B  ?,Ay(B  32  ?,AS(B
	?,Aa(B  ?,Am(B  ?,As(B  ?,Az(B  ?,Aq(B  ?,AQ(B  ?,A*(B  ?,A:(B  ?,A?(B  ?,AR(B  ?,A,(B  ?,A=(B  ?,A<(B  ?,A!(B  ?,A+(B  ?,A;(B
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	?,Fa(B  ?,A_(B  ?,FC(B  ?,FP(B  ?,FS(B  ?,Fs(B  ?,Fl(B  ?,Fc(B  ?,Fv(B  ?,FH(B  ?,FY(B  ?,Fd(B  32  ?,Ax(B  32  32
	32  ?,A1(B  32  32  32  32  ?,Aw(B  32  ?,A0(B  32  ?,A7(B  32  32  ?,A2(B  32  32]))))
  "CCL program to read Code Page 860.")

(define-ccl-program ccl-write-codepage-860
  '(1
    ((read r0)
     (loop
      (if (r0 != 129)			; lc-ltn1 == 129
	  (if (r0 != 134)		; lc-grk == 134
	      (write-read-repeat r0)
	    ((read r0)
	     (r0 -= 160)
	     (write-read-repeat
	      r0
	      [32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  226 32  32  32  32  233 32  32  32  32  32  32  32 
	       32  32  32  228 32  32  232 32  32  234 32  32  32  32  32  32 
	       32  224 32  231 235 32  32  32  32  32  32  32  230 32  32  32
	       32  32  32  229 32  32  32  32  32  32  32  32  32  32  32  32])))
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  173 155 156 32  32  124 37  32  32  166 174 170 32  32  32
	   248 241 253 32  32  230 36  249 32  32  167 175 172 171 32  168
	   32  32  143 142 32  32  32  128 146 144 137 32  152 139 32  32
	   32  165 169 159 140 153 32  32  32  157 150 32  154 32  32  32
	   133 160 131 132 32  32  32  135 142 130 136 32  141 161 32  32
	   32  164 149 162 146 147 32  246 32  151 163 32  129 32  32  32]))
	))))
  "CCL program to write Code Page 860.")

(make-coding-system
 '*cp-860* 4
 ?c "Coding-system used for Code Page 860"
 2
 (cons ccl-read-codepage-860 ccl-write-codepage-860))

(defun set-codepage-environment-860 ()
  "Make Code Page 860 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-860*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-860*)
  (set-file-coding-system '*cp-860*)
  (set-display-coding-system '*cp-860*)
  (setq-default quail-current-package (assoc "cp-860" quail-package-alist)))

(put 'cp-860 'primary-function 'set-codepage-environment-860)
(add-hook 'quail-package-alist '("cp-860" "quail/codepage"))

;; Code Page 863 (French Canada) staff

(define-ccl-program ccl-read-codepage-863
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,A'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,AG(B  ?,A|(B  ?,Ai(B  ?,Ab(B  ?,AB(B  ?,A`(B  32  ?,Ag(B  ?,Aj(B  ?,Ak(B  ?,Ah(B  ?,Ao(B  ?,An(B  32  ?,A@(B  ?,A'(B
	?,AI(B  ?,AH(B  ?,AJ(B  ?,At(B  ?,AK(B  ?,AO(B  ?,A{(B  ?,Ay(B  ?,A$(B  ?,AT(B  ?,A\(B  ?,A"(B  ?,A#(B  ?,AY(B  ?,A[(B  32
	?,A&(B  ?,A4(B  ?,As(B  ?,Az(B  ?,A((B  ?,A8(B  ?,A3(B  ?,A/(B  ?,AN(B  32  ?,A,(B  ?,A=(B  ?,A<(B  ?,A>(B  ?,A+(B  ?,A;(B
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	?,Fa(B  ?,A_(B  ?,FC(B  ?,FP(B  ?,FS(B  ?,Fs(B  ?,Fl(B  ?,Fc(B  ?,Fv(B  ?,Fh(B  ?,FY(B  ?,Fd(B  32  ?,Ax(B  32  32
	32  ?,A1(B  32  32  32  32  ?,Aw(B  32  ?,A0(B  32  ?,A7(B  32  32  ?,A2(B  32  32]))))
  "CCL program to read Code Page 863.")

(define-ccl-program ccl-write-codepage-863
  '(1
    ((read r0)
     (loop
      (if (r0 != 129)			; lc-ltn1 == 129
	  (if (r0 != 134)		; lc-grk == 134
	      (write-read-repeat r0)
	    ((read r0)
	     (r0 -= 160)
	     (write-read-repeat
	      r0
	      [32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  226 32  32  32  32  233 32  32  32  32  32  32  32 
	       32  32  32  228 32  32  232 32  32  234 32  32  32  32  32  32 
	       32  224 32  231 235 32  32  32  32  32  32  32  230 32  32  32
	       32  32  32  229 32  32  32  32  32  32  32  32  32  32  32  32])))
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  32  155 156 152 32  160 143 164 32  32  174 170 32  32  167
	   248 241 253 166 161 230 134 250 165 32  32  175 172 171 173 32
	   142 32  132 32  32  32  32  128 145 144 146 148 32  32  168 149
	   32  32  32  32  153 32  32  32  32  32  32  158 154 32  32  32
	   133 32  131 32  32  32  32  135 138 130 136 137 32  32  140 139
	   32  32  32  162 147 32  32  246 32  151 163 150 129 32  32  32]))
	))))
  "CCL program to write Code Page 863.")

(make-coding-system
 '*cp-863* 4
 ?c "Coding-system used for Code Page 863"
 2
 (cons ccl-read-codepage-863 ccl-write-codepage-863))

(defun set-codepage-environment-863 ()
  "Make Code Page 863 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-863*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-863*)
  (set-file-coding-system '*cp-863*)
  (set-display-coding-system '*cp-863*)
  (setq-default quail-current-package (assoc "cp-863" quail-package-alist)))

(put 'cp-863 'primary-function 'set-codepage-environment-863)
(add-hook 'quail-package-alist '("cp-863" "quail/codepage"))

;; Code Page 865 (Nordic) staff

(define-ccl-program ccl-read-codepage-865
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [32  32  32  32  32  32  32  32  32  32  10  32  32  13  32  32
	32  32  32  32  ?,A6(B  ?,A'(B  32  32  32  32  32  32  32  32  32  32
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	?,AG(B  ?,A|(B  ?,Ai(B  ?,Ab(B  ?,Ad(B  ?,A`(B  ?,Ae(B  ?,Ag(B  ?,Aj(B  ?,Ak(B  ?,Ah(B  ?,Ao(B  ?,An(B  ?,Al(B  ?,AD(B  ?,AE(B
	?,AI(B  ?,Af(B  ?,AF(B  ?,At(B  ?,Av(B  ?,Ar(B  ?,A{(B  ?,Ay(B  ?,A(B  ?,AV(B  ?,A\(B  ?,Ax(B  ?,A#(B  ?,AX(B  32  32
	?,Aa(B  ?,Am(B  ?,As(B  ?,Az(B  ?,Aq(B  ?,AQ(B  ?,A*(B  ?,A:(B  ?,A?(B  32  ?,A,(B  ?,A=(B  ?,A<(B  ?,A!(B  ?,A+(B  ?,A$(B
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32
	?,Fa(B  ?,A_(B  ?,FC(B  ?,FP(B  ?,FS(B  ?,Fs(B  ?,Fl(B  ?,Fc(B  ?,Fv(B  ?,Fh(B  ?,FY(B  ?,Fd(B  32  ?,Ax(B  32  32
	32  ?,A1(B  32  32  32  32  ?,Aw(B  32  ?,A0(B  32  ?,A7(B  32  32  ?,A2(B  32  32]))))
  "CCL program to read Code Page 865.")

(define-ccl-program ccl-write-codepage-865
  '(1
    ((read r0)
     (loop
      (if (r0 != 129)			; lc-ltn1 == 129
	  (if (r0 != 134)		; lc-grk == 134
	      (write-read-repeat r0)
	    ((read r0)
	     (r0 -= 160)
	     (write-read-repeat
	      r0
	      [32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  32  32  32  32  32  32  32  32  32  32  32  32  32 
	       32  32  32  226 32  32  32  32  233 32  32  32  32  32  32  32 
	       32  32  32  228 32  32  232 32  32  234 32  32  32  32  32  32 
	       32  224 32  231 235 32  32  32  32  32  32  32  230 32  32  32
	       32  32  32  229 32  32  32  32  32  32  32  32  32  32  32  32])))
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  173 32  156 175 32  32  37  32  32  166 174 170 32  32  32
	   248 241 253 32  32  230 36  250 32  32  167 32  172 171 32  168
	   32  32  32  32  142 143 146 128 32  144 32  32  32  32  32  32
	   32  165 32  32  32  32  153 32  32  32  32  32  154 32  32  32
	   133 160 131 32  132 134 145 135 138 32  136 137 141 161 140 139
	   32  164 149 162 147 32  148 246 32  151 163 150 129 32  32  32]))
	))))
  "CCL program to write Code Page 865.")

(make-coding-system
 '*cp-865* 4
 ?c "Coding-system used for Code Page 865"
 2
 (cons ccl-read-codepage-865 ccl-write-codepage-865))

(defun set-codepage-environment-865 ()
  "Make Code Page 865 the default charcter set Code Page."
  (setq *coding-category-bin* '*cp-865*)

  (set-coding-priority
   '(*coding-category-bin*))
  (set-default-file-coding-system '*cp-865*)
  (set-file-coding-system '*cp-865*)
  (set-display-coding-system '*cp-865*)
  (setq-default quail-current-package (assoc "cp-865" quail-package-alist)))

(put 'cp-865 'primary-function 'set-codepage-environment-865)
(add-hook 'quail-package-alist '("cp-865" "quail/codepage"))

(nconc *modify-file-coding-system-for-read-alist*
       '((cp-437 . *cp-437*)
	 (cp-850 . *cp-850*)
	 (cp-852 . *cp-852*)
	 (cp-860 . *cp-860*)
	 (cp-863 . *cp-863*)))

(provide 'codepage)
