/**************************************
  Mule for Win32 Fontset Manager
       Written by himi
**************************************/
#ifdef MULE
#ifndef __WIN32_FONTSET__
#define __WIN32_FONTSET__
#include <windows.h>

#define FONT_PROPERTY_NUM 16
#define LOGFONT_FACENAME_MAX 32

#define NORMAL_FONT_PROPERTY 0
#define BOLD_FONT_PROPERTY 1
#define ITALIC_FONT_PROPERTY 2
#define ITALIC_BOLD_FONT_PROPERTY 3

#define FS_GET_LOGFONT(font, property) ((font)->logfont_properties[(property)])
#define FS_GET_FONT(font, property) ((font)->font_properties[(property)])
#define FS_NUM (current_fontset -> font_num)

#define CURRENT_FONTSET FRAME_FONTSET(selected_frame)

/* patch 96.11.18  by K.Fujii */
#ifndef RUSSIAN_CHARSET
#define HEBREW_CHARSET          177
#define ARABIC_CHARSET          178
#define GREEK_CHARSET           161
#define TURKISH_CHARSET         162
#define THAI_CHARSET            222
#define EASTEUROPE_CHARSET      238
#define RUSSIAN_CHARSET         204

#define MAC_CHARSET             77
#define BALTIC_CHARSET          186
#endif
/* end of patch */

typedef struct fs_fonts
{
  unsigned char *name;
  /*  int fsCharSet; */		/* 96.11.9  by K.Fujii */
  Lisp_Object coding_system;
  LOGFONT *logfont_properties[FONT_PROPERTY_NUM];
  HFONT   font_properties[FONT_PROPERTY_NUM];
} fs_fonts;

typedef struct win32_fontset
{
  unsigned char *fs_name;
  int vmetric;
  int hmetric;
  int font_base;
  int overhang;
  /* int font_num; */
  LOGFONT *ime_font;		/* 97.5.15  by K.Fujii */
  fs_fonts *fonts[128];
} win32_fontset;

extern HFONT get_hfont(win32_fontset *fs, fs_fonts *sf, int property);
extern LPLOGFONT get_logfont(win32_fontset *fs, fs_fonts *sf, int property);
extern void win32_set_ime_font(HWND hwnd, LPLOGFONT psetlf);
extern void win32_change_fontset(struct frame *f, unsigned char *name);
extern HFONT win32_fs_load_font (win32_fontset *fs, int lc, int property, Lisp_Object *coding_system);
extern LPLOGFONT get_logfont_ime (win32_fontset *fs);
#endif  /* __WIN32_FONTSET__ */
#endif  /* MULE */

